# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import pydantic
from .identity_type import IdentityType
import typing
from .agent_state import AgentState
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class Identity(UncheckedBaseModel):
    id: str = pydantic.Field()
    """
    The internal id of the identity.
    """

    identifier_key: str = pydantic.Field()
    """
    External, user-generated identifier key of the identity.
    """

    name: str = pydantic.Field()
    """
    The name of the identity.
    """

    identity_type: IdentityType = pydantic.Field()
    """
    The type of the identity.
    """

    project_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    The project id of the identity, if applicable.
    """

    agents: typing.List[AgentState] = pydantic.Field()
    """
    The agents associated with the identity.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
